Attribute VB_Name = "defResource"
Option Explicit

'definition file for Resource Class!

' header of RES file (= 8 bytes)
Public Type rcHeader
    lSize As Long                           ' filesize (4 bytes)
    iNumber As Integer                      ' number of resources (2 bytes)
End Type

' header included for every resource (= 44 bytes)
Public Type rcInfo
    bType As Byte                           ' type of resource (2 bytes)
    lSize As Long                           ' size of resource (4 bytes)
    lBegin As Long                          ' begining byte of resource (4 bytes)
    sKeyID As String * 15                   ' ID of resource (15 bytes)
End Type

' resource type constants
Public Const rc_Bitmap As Byte = 0          ' for bitmaps
Public Const rc_Sound As Byte = 1           ' for sound buffer
Public Const rc_Table As Byte = 2           ' for data tables
Public Const rc_Binary As Byte = 3          ' for binary files
Public Const rc_Chain As Byte = 4            ' for a single string

' for user input
Public Enum rcTypes
    rcBitmap = rc_Bitmap
    rcWave = rc_Sound
    rcTable = rc_Table
    rcBinary = rc_Binary
    rcChain = rc_Chain
    rcNoType = -1
End Enum
