VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CResourceHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Handles compiled resource scripts."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit


'   Dieser Source stammt von http://www.activevb.de
'   und kann frei verwendet werden. Fr eventuelle Schden
'   wird nicht gehaftet.
'
'   Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'   Ansonsten viel Spa und Erfolg mit diesem Source !
'
'   Autor:  Konrad Rudolph <Konrad_Rudolph@ActiveVB.de>
'
'****************************************************
'* CResourceHandler.cls                             *
'* Resource create & handle class                   *
'* Programmed: Konrad Rudolph, Mad Rat Pro.         *
'* Last Change: 01/12/2001 15:10                    *
'* Freeware: do with it whatever you want to as     *
'*  long as it's not commercial!                    *
'* Version: 2.0.0                                   *
'****************************************************
'* Allows to create and handle resource files with  *
'* the following features:                          *
'*  - bitmaps (no compressing, .bmp)                *
'*  - waves (sound buffer, .wav)                    *
'*  - tables (text & data access)                   *
'*  - strings (data storage in one string)          *
'*  - if nothing fits, just store a binary file     *
'*  - all this stuff in one file                    *
'*  - access using keywords (IDs)                   *
'*  - creating of resource script files             *
'*  - bases on scripts (*.rc), compiles to *.res    *
'*    files (compiled resource files)               *
'****************************************************

'ToDo:
'Yet Implemented (fully de-bugged):
' - GetType
' - GetBegin
' - GetLength
' - Count
' - Initialize
' - Unload
' - GetData
' - GetFile
' - GetSurface
' - GetChain
'
'Not yet finished:
' - GetWave
' - GetBitmap (does not function on PictureBoxes)

'include <defResource.bas>
'include <defBitmap.bas>

' change this value if you want to use GetSurface
#Const EnableDirectX = False

Private iChannel As Integer                 ' file access channel
Private iNumber As Integer                  ' number of resources
Private iCount As New Collection            ' number to enumerate resources
Private sID As New Collection               ' IDs of resources
Private bType As New Collection             ' types of resources
Private lSize As New Collection             ' sizes of resources
Private lStart As New Collection            ' first byte of resource
Private InfoHeader() As rcInfo              ' resource information for header
Private bmfFileHeader As BITMAPFILEHEADER   ' stores BMP file information
Private bmiInfo As BITMAPINFO               ' stores BMP information
Private bData() As Byte                     ' stores BMP data

' returns the number of resources
Public Property Get Count() As Integer
    Count = iNumber
End Property

' initializes the resource handle
Public Function Initialize(ByVal Resource As String) As Long
    Dim Header As rcHeader, I As Integer
    
    If iChannel <> 0 Then Exit Function
    If LTrim$(Right$(Resource, 4)) <> ".res" Then Resource = Resource + ".res"
    If Resource = "" Or Dir$(Resource) = "" Then Exit Function
    
    iChannel = FreeFile
    Open Resource For Binary As #iChannel
    Get #iChannel, , Header
    iNumber = Header.iNumber
    ReDim InfoHeader(1 To iNumber) As rcInfo
    Get #iChannel, , InfoHeader()
    For I = 1 To iNumber
        With InfoHeader(I)
            sID.Add RTrim$(.sKeyID), RTrim$(.sKeyID)
            bType.Add .bType, RTrim$(.sKeyID)
            lSize.Add .lSize, RTrim$(.sKeyID)
            lStart.Add .lBegin, RTrim$(.sKeyID)
        End With
    Next
    Initialize = Header.lSize
End Function

' unloads resource handle
Public Sub Unload()
    If iChannel = 0 Then Exit Sub
    Close #iChannel
    iChannel = 0
End Sub

' loads data into file Destination, returns the handle of the opened file channel
Public Function GetFile(ByVal ID As String, ByVal Destination As String) As Integer
    Dim Position As Long
    Dim Length As Long
    Dim A As String
    
    On Error GoTo ErrorGetFile
    If Destination = "" Then Exit Function
        
    Position = GetBegin(ID)
    Length = GetLength(ID)
    If Length = -1 Or Position = -1 Then
        On Error GoTo 0
        Exit Function
    End If
    
    A = Space$(Length)
    Get #iChannel, Position, A
    GetFile = FreeFile
    Open Destination For Binary As #GetFile
    If LOF(GetFile) > 0 Then
        Close #GetFile
        Kill Destination
        Open Destination For Binary As #GetFile
    End If
    Put #GetFile, , A
    On Error GoTo 0
    Exit Function
    
ErrorGetFile:
    On Error GoTo 0
    Close #GetFile
    Kill Destination
    GetFile = 0
End Function

' sets a bitmap to target DC (picturebox...) using API
Public Sub GetBitmap(ByVal ID As String, ByVal DC As Long)
    'parts of this function taken from Lucky's site
    Dim I As Integer
    Dim Position As Long

    Position = GetBegin(ID)
    If Position = 0 Then Exit Sub
    
    'Init variables
    Erase bmiInfo.bmiColors
    Get #iChannel, Position, bmfFileHeader
    'Fill the Info structure
    Get #iChannel, , bmiInfo.bmiHeader
    If bmiInfo.bmiHeader.biClrUsed <> 0 Then
        For I = 0 To bmiInfo.bmiHeader.biClrUsed - 1
            Get #iChannel, , bmiInfo.bmiColors(I).rgbBlue
            Get #iChannel, , bmiInfo.bmiColors(I).rgbGreen
            Get #iChannel, , bmiInfo.bmiColors(I).rgbRed
            Get #iChannel, , bmiInfo.bmiColors(I).rgbReserved
        Next I
    ElseIf bmiInfo.bmiHeader.biBitCount = 8 Then
        Get #iChannel, , bmiInfo.bmiColors
    End If
    'Size the bData array
    If bmiInfo.bmiHeader.biBitCount = 8 Then
        ReDim bData(FileSize(bmiInfo.bmiHeader.biWidth, bmiInfo.bmiHeader.biHeight))
    Else
        ReDim bData(bmiInfo.bmiHeader.biSizeImage - 1)
    End If
    'Fill the bData array
    Get #iChannel, , bData
    'Ensure info is correct
    If bmiInfo.bmiHeader.biBitCount = 8 Then
        bmfFileHeader.bfOffBits = 1078
        bmiInfo.bmiHeader.biSizeImage = FileSize(bmiInfo.bmiHeader.biWidth, bmiInfo.bmiHeader.biHeight)
        bmiInfo.bmiHeader.biClrUsed = 0
        bmiInfo.bmiHeader.biClrImportant = 0
        bmiInfo.bmiHeader.biXPelsPerMeter = 0
        bmiInfo.bmiHeader.biYPelsPerMeter = 0
    End If

    StretchDIBits DC, 0, 0, bmiInfo.bmiHeader.biWidth, _
      bmiInfo.bmiHeader.biHeight, 0, 0, bmiInfo.bmiHeader.biWidth, _
      bmiInfo.bmiHeader.biHeight, bData(0), bmiInfo, 0, SRCCOPY
End Sub

#If EnableDirectX Then

' blits a bitmap into a surface that is returned by the function
Public Function GetSurface(ID As String, ddsd As DDSURFACEDESC2) As DirectDrawSurface7
    'parts of this function taken from Lucky's site
    Dim I As Integer
    Dim Position As Long
    Dim Surface As DirectDrawSurface7
    Dim hdc As Long
    On Error GoTo ErrorGetSurface

    Position = GetBegin(ID)
    If Position = 0 Then Exit Function
    If GetType(ID) <> rcBitmap Then Exit Function
    
    'Init variables
    Erase bmiInfo.bmiColors
    Get #iChannel, Position, bmfFileHeader
    'Fill the Info structure
    Get #iChannel, , bmiInfo.bmiHeader
    If bmiInfo.bmiHeader.biClrUsed <> 0 Then
        For I = 0 To bmiInfo.bmiHeader.biClrUsed - 1
            Get #iChannel, , bmiInfo.bmiColors(I).rgbBlue
            Get #iChannel, , bmiInfo.bmiColors(I).rgbGreen
            Get #iChannel, , bmiInfo.bmiColors(I).rgbRed
            Get #iChannel, , bmiInfo.bmiColors(I).rgbReserved
        Next I
    ElseIf bmiInfo.bmiHeader.biBitCount = 8 Then
        Get #iChannel, , bmiInfo.bmiColors
    End If
    'Size the bData array
    If bmiInfo.bmiHeader.biBitCount = 8 Then
        ReDim bData(FileSize(bmiInfo.bmiHeader.biWidth, bmiInfo.bmiHeader.biHeight))
    Else
        ReDim bData(bmiInfo.bmiHeader.biSizeImage - 1)
    End If
    'Fill the bData array
    Get #iChannel, , bData
    'Ensure info is correct
    If bmiInfo.bmiHeader.biBitCount = 8 Then
        bmfFileHeader.bfOffBits = 1078
        bmiInfo.bmiHeader.biSizeImage = FileSize(bmiInfo.bmiHeader.biWidth, bmiInfo.bmiHeader.biHeight)
        bmiInfo.bmiHeader.biClrUsed = 0
        bmiInfo.bmiHeader.biClrImportant = 0
        bmiInfo.bmiHeader.biXPelsPerMeter = 0
        bmiInfo.bmiHeader.biYPelsPerMeter = 0
    End If

    ddsd.lWidth = bmiInfo.bmiHeader.biWidth
    ddsd.lHeight = bmiInfo.bmiHeader.biHeight
    Set Surface = DD.CreateSurface(ddsd)
    hdc = Surface.GetDC
    StretchDIBits hdc, 0, 0, bmiInfo.bmiHeader.biWidth, _
      bmiInfo.bmiHeader.biHeight, 0, 0, bmiInfo.bmiHeader.biWidth, _
      bmiInfo.bmiHeader.biHeight, bData(0), bmiInfo, 0, SRCCOPY
    Surface.ReleaseDC hdc
    Set GetSurface = Surface
    Set Surface = Nothing
    Exit Function
    
ErrorGetSurface:
    Set GetSurface = Nothing
    On Error GoTo 0
End Function

#End If

' returns a string that contains data
Public Function GetChain(ByVal ID As String) As String
    Dim Position As Long, Length As Long
    On Error GoTo ErrorGetChain
    
    Position = GetBegin(ID)
    Length = GetLength(ID)
    If Length = -1 Or Position = -1 Then
        On Error GoTo 0
        Exit Function
    End If
    If GetType(ID) <> rcChain Then
        On Error GoTo 0
        Exit Function
    End If
    
    GetChain = Space$(Length)
    Get #iChannel, Position, GetChain
    
    On Error GoTo 0
    Exit Function
    
ErrorGetChain:
    GetChain = ""
    On Error GoTo 0
End Function

' Reads a data table into a collection
' if the flag ReadID is set, then each second entry will be handled as an ID and the
' following as its data
Public Function GetData(ByVal ID As String, Optional ByVal ReadID As Boolean = True) As Collection
    Dim Position As Long, Length As Long
    Dim A As String, I As Long
    Dim QuoteFlag As Boolean                    ' whether the actual string is quoted
    Dim LastQuotePos As Long                    ' position of last quote sign
    Dim ActualString As String                  ' the actual string
    Dim ActualKey As String                     ' actual ID
    Dim Count As Integer                        ' number of items
    On Error GoTo ErrorGetData
    
    Position = GetBegin(ID)
    Length = GetLength(ID)
    If Length = -1 Or Position = -1 Then
        On Error GoTo 0
        Exit Function
    End If
    If GetType(ID) <> rcTable Then
        On Error GoTo 0
        Exit Function
    End If
    
    Set GetData = New Collection
    A = Space$(Length)
    Get #iChannel, Position, A
    For I = 1 To Len(A)
        Select Case Mid$(A, I, 1)
        Case """"
            If QuoteFlag Then
                If LastQuotePos = I - 1 And LastQuotePos <> 0 Then
                    QuoteFlag = False
                    ActualString = ActualString + """"
                Else
                    If Mid$(A, I + 1, 1) = """" Then
                        ActualString = ActualString + """"
                        I = I + 1
                        LastQuotePos = I
                    Else
                        If ReadID Then
                            If ActualKey = "" Then
                                ActualKey = ActualString
                                ActualString = ""
                                QuoteFlag = False
                            Else
                                GetData.Add ActualString, ActualKey
                                ActualString = ""
                                ActualKey = ""
                                QuoteFlag = False
                            End If
                        Else
                            GetData.Add ActualString, LTrim$(Str$(Count))
                            ActualString = ""
                            QuoteFlag = False
                            Count = Count + 1
                        End If
                    End If
                End If
            Else
                QuoteFlag = True
                If ActualString <> "" Then
                    If ReadID Then
                        If ActualKey = "" Then
                            ActualKey = ActualString
                            ActualString = ""
                        Else
                            GetData.Add ActualString, ActualKey
                            ActualString = ""
                            ActualKey = ""
                        End If
                    Else
                        GetData.Add ActualString, LTrim$(Str$(Count))
                        ActualString = ""
                        Count = Count + 1
                    End If
                End If
            End If
        Case ";"
            If QuoteFlag Then
                ActualString = ActualString + ";"
            Else
                If ReadID Then
                    If ActualKey = "" Then
                        ActualKey = ActualString
                        ActualString = ""
                    Else
                        GetData.Add ActualString, ActualKey
                        ActualString = ""
                        ActualKey = ""
                    End If
                Else
                    GetData.Add ActualString, LTrim$(Str$(Count))
                    ActualString = ""
                    Count = Count + 1
                End If
            End If
        Case Else
            ActualString = ActualString + Mid$(A, I, 1)
        End Select
    Next
    If ActualString <> "" Then
        If ReadID Then
            If ActualKey <> "" Then
                GetData.Add ActualString, ActualKey
            End If
        Else
            GetData.Add ActualString, LTrim$(Str$(I))
        End If
    End If
    On Error GoTo 0
    Exit Function
    
ErrorGetData:
    Set GetData = Nothing
    On Error GoTo 0
End Function

' returns the size of a resource
Public Function GetLength(ByVal ID As String) As Long
    On Error GoTo ErrorGetLength
    GetLength = lSize.Item(ID)
    On Error GoTo 0
    Exit Function
    
ErrorGetLength:
    On Error GoTo 0
    GetLength = -1
End Function

' returns the first byte's position of a resource
Public Function GetBegin(ByVal ID As String) As Long
    On Error GoTo ErrorGetBegin
    GetBegin = lStart.Item(ID)
    On Error GoTo 0
    Exit Function
    
ErrorGetBegin:
    On Error GoTo 0
    GetBegin = -1
End Function

' returns the resource type
Public Function GetType(ByVal ID As String) As rcTypes
    On Error GoTo ErrorGetType
    GetType = bType.Item(ID)
    On Error GoTo 0
    Exit Function
    
ErrorGetType:
    On Error GoTo 0
    GetType = rcNoType
End Function

' function taken from Lucky's site
' returns the size of the bitmap file body
Private Function FileSize(Width As Long, Height As Long) As Long
    If Width Mod 4 > 0 Then
        FileSize = ((Width \ 4) + 1) * 4 * Height - 1
    Else
        FileSize = Width * Height - 1
    End If
End Function
